// *******************************************************
//   COPYRIGHT(C) 2017                                    
//   Toshiba Development & Engineering Corporation       
//   ALL RIGHTS RESERVED                                  
// *******************************************************
/**
 * @file	iSDIO_tutorial_sample.c
 * @brief	iSDIO`[gATvR[h
 *
 * @see
 *   - Part E7 iSDIO Simplified Specification Version 1.10 March 25, 2014
 *   - Part E7 Wireless LAN Simplified Addendum Version 1.10 March 25, 2014
 */

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/mount.h>
#include <sys/stat.h>

#include "../../inc/isdioreg.h"
#include "../../inc/isdio_api.h"
#include "../../inc/isdio_wlan_api.h"

static bool_t response_wait(iSDIO_INFO_t *, uint32_t, uint32_t, int32_t);

/* C^[lbgڑ[hݒTv֐ */
int main(void) {

    iSDIO_INFO_t *s_info;                                   /* iSDIOJ[h|C^ */
    char *s_device = "/dev/mmcblk0" ;                       /* SDJ[hfoCX */
    int32_t result;
    uint32_t s_seq_id = 0;                                  /* V[PXID */
    bool_t cmd_success;                                     /* X|X҂ */
    uint8_t apssid[32]          = "myflashair";             /* FlashAiriAPj LAN SSID */
    uint8_t apnetworkKey[64]    = "password0123";           /* FlashAiriAPj LAN lbg[NL[ */
    uint8_t brgssid[32]         = "LANSSID";                /* C^[lbgiSTAj LAN SSID */
    uint8_t brgnetworkKey[64]   = "lanpassword0123";        /* C^[lbgiSTAj LAN lbg[NL[ */
    uint32_t encMode            = iSDIO_WLAN_ENCMODE_WPA2_PSK_AND_AES;  /* 샂[h=6 */
    uint8_t getssid[32]         = {0};                      /* ANZX|Cg擾obt@ */
    uint8_t lp;
    uint8_t num = 0;
    int32_t timeout;

    /* iSDIO */
    s_info = iSDIO_Init(s_device);
    printf(" info=0x%p\n", s_info);
    if (s_info != NULL) {
        printf("info->fno=%d\n", s_info->fno);
        system("mount /dev/mmcblk0p1 /mnt");
        /* ̃ANZX|Cg̏擾 */
        result = iSDIO_WLAN_Scan(s_info, s_seq_id ++);

        if (result == E_iSDIO_OK) {
            /* iSDIOR}hsvZX̊҂ */
            timeout = 20000;          /* Scañ^CAEg20bȂ̂ŁA20000ms */
            cmd_success = FALSE;
            /* WLAN_ScanX|X҂ */
            cmd_success = response_wait(s_info, (s_seq_id-1), iSDIO_WLAN_SCAN, timeout);

            if (cmd_success == FALSE) {
                printf("WLAN_Scan response error !!!\n");
            }
            else {
                /* WLAN_ScanŎ擾񂩂ANZX|Cg擾 */
                result = iSDIO_WLAN_GetSSIDs(s_info, &num);
                if(result != E_iSDIO_OK) {
                    printf("WLAN_GetSSIDs get error !!!\n");
                    exit(0);
                }
                if(num==0) {
                    /* ɃANZX|CgȂꍇ */
                    printf("no SSID\n");
                }
                else {
                    /* ɃANZX|Cgꍇ */
                    /* ANZX|Cg擾đΏۂSTA邩 */
                    for(lp=0;lp<num;lp++) {
                        memset(getssid,0x00,32);            /* ANZX|Cg擾pobt@NA */
                        /* wԍ̃ANZX|Cg擾 */
                        result = iSDIO_WLAN_GetSSID(s_info, lp , getssid);
                        if(result != E_iSDIO_OK) {
                            printf("WLAN_GetSSID get error !!!\n");
                            exit(0);
                        }
                        printf("SSID#%d SSID=%s\n",lp, getssid);
                        if(strstr((const char *)getssid, (const char *)brgssid)) {
                            /* ΏۂSTABridgeݒ*/
                            result = iSDIO_WLAN_Bridge(s_info, s_seq_id++,
                                        apssid, sizeof(apssid),
                                        apnetworkKey, sizeof(apnetworkKey),
                                        encMode,
                                        brgssid, sizeof(brgssid),
                                        brgnetworkKey, sizeof(brgnetworkKey));
                            if(result != E_iSDIO_OK) {
                                printf("Bridge Set error!!!\n");
                                exit(0);
                            }
                            break;
                        }
                    }
                    if(lp>=num){
                        /* ɑΏۂSTAȂ */
                        printf("not find STA SSID\n");
                    }
                    else {
                        timeout = 2000;
                        cmd_success = FALSE;
                        /* WLAN_BrigeX|X҂ */
                        cmd_success = response_wait(s_info, (s_seq_id-1), iSDIO_WLAN_BRIDGE, timeout);
                        if(cmd_success == FALSE) {
                            /* WLAN_BridgeR}hُI*/
                            printf("WLAN_Bridge rasponse error !!! \n");
                        }
                        else{
                            printf("WLAN_Bridge set success\n!");
                            /* ݒ肵ubW擾 */
                            result = iSDIO_WLAN_BridgeGetInfoByRegister(s_info, s_seq_id++);
                            if(result != E_iSDIO_OK) {
                                printf("WLAN_GetSSIDs get error !!!\n");
                                exit(0);
                            }
                            /* iSDIO_WLAN_BridgeGetInfoByRegisterX|X҂ */
                            timeout = 2000;
                            cmd_success = FALSE;
                            cmd_success = response_wait(s_info, (s_seq_id-1), iSDIO_WLAN_BRIDGE_GET_INFO_BY_REGISTER, timeout);
                            if(cmd_success == FALSE) {
                                /* WLAN_BridgeGetInfoByRegisterR}hُI*/
                                printf("WLAN_BridgeGetInfoByRegister response error !!! \n");
                             }
                            else {
                                /* ubWݒ_v */
                                printf("WLAN_BridgeGetInfoByRegister get response success\n");
                            }
                        }
                    }
                }
            }
        }
        else {
            printf("WLAN_Scan get error !!!\n!");
        }
    }
    else {
        printf("WLAN_Init error !!!\n");
    }
}
/* R}hX|X҂Tv֐ */
static bool_t response_wait(iSDIO_INFO_t *s_info, uint32_t seq_id, uint32_t cmd_id, int32_t timeout)
{
    iSDIO_CommandResponseStatus_t *status;
    int32_t timeout_cnt = timeout / 10;    // ms / 10
    bool_t cmd_success = FALSE;

    /* R}hX|XXe[^Xs甲邩^CAEg܂Ń[v */
    do {
        status = iSDIO_ReadCommandResponseStatus(s_info);
        if ((status->response_status != iSDIO_COMMAND_PROCESSING) && (status->cmd_id==cmd_id)) {
            if (status->response_status == iSDIO_PROCESS_SUCCEEDED) {
                cmd_success = TRUE;
            }
            break;
            printf("res_wait=%d\n",status->response_status);
        }
        sleep(10);    /* 10ms҂ */
        timeout_cnt --;
    } while (timeout_cnt > 0);
    return cmd_success;
}
